VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cCenterPicture"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, _
    ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, _
    ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
    
Private Declare Function GetPixel Lib "gdi32.dll" (ByVal hdc As Long, ByVal nXPos As Long, ByVal nYPos As Long) As Long


Public Sub CenterImage(picSource As Object, picCenter As Object)
    On Error GoTo ErrorHandler
    Dim intX1       As Integer
    Dim intX2       As Integer
    Dim intY1       As Integer
    Dim intY2       As Integer
    Dim X           As Integer
    Dim Y           As Integer
    Dim intFinalX   As Integer
    Dim intFinalY   As Integer
    Dim intFinalW   As Integer
    Dim intFinalH   As Integer
    Dim intResult   As Long
        
    For X = 0 To picSource.ScaleWidth
        For Y = 0 To picSource.ScaleHeight
            If GetPixel(picSource.hdc, X, Y) = 0 Then
                intX1 = X
                Exit For
            End If
        Next
        If intX1 Then
            Exit For
        End If
    Next
    
    For X = picSource.ScaleWidth To 0 Step -1
        For Y = 0 To picSource.ScaleHeight
            If GetPixel(picSource.hdc, X, Y) = 0 Then
                intX2 = X
                Exit For
            End If
        Next
        If intX2 Then
            Exit For
        End If
    Next
    
    For Y = 0 To picSource.ScaleHeight
        For X = picSource.ScaleWidth To 0 Step -1
            If GetPixel(picSource.hdc, X, Y) = 0 Then
                intY1 = Y
                Exit For
            End If
        Next
        If intY1 Then
            Exit For
        End If
    Next

    For Y = picSource.ScaleHeight To 0 Step -1
        For X = picSource.ScaleWidth To 0 Step -1
            If GetPixel(picSource.hdc, X, Y) = 0 Then
                intY2 = Y
                Exit For
            End If
        Next
        If intY2 Then
            Exit For
        End If
    Next
    intFinalW = (intX2 - intX1) + 1
    intFinalH = (intY2 - intY1) + 1
    intFinalX = (picSource.ScaleWidth - (intX2 - intX1)) / 2
    intFinalY = (picSource.ScaleHeight - (intY2 - intY1)) / 2
    
    
    picCenter.AutoRedraw = True
    intResult = BitBlt(picCenter.hdc, intFinalX, intFinalY, intFinalW, intFinalH, picSource.hdc, intX1, intY1, vbSrcCopy)
    Set picCenter.Picture = picCenter.Image
    'Set picSource.Picture = picCenter.Image
    Exit Sub
    
ErrorHandler:
End Sub

